您的位置:首页 > 其它

Robberies(HDU-2955)

2017-05-22 17:54 281 查看
[align=left]Problem Description[/align]
The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only
for a short while, before retiring to a comfortable job at a university.



For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.

His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.
 

[align=left]Input[/align]
The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then
follow N lines, where line j gives an integer Mj and a floating point number Pj .

Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .
 

[align=left]Output[/align]
For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints

0 < T <= 100

0.0 <= P <= 1.0

0 < N <= 100

0 < Mj <= 100

0.0 <= Pj <= 1.0

A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.
 

[align=left]Sample Input[/align]

3
0.04 3
1 0.02
2 0.03
3 0.05
0.06 3
2 0.03
2 0.03
3 0.05
0.10 3
1 0.03
2 0.02
3 0.05

 

[align=left]Sample Output[/align]

2
4
6

 

题意:小偷偷银行,不能重复的偷,t个测试数列,然后输入能接受的风险p,和n家银行,每家银行都有资金和被抓概率,问最多能偷多少钱;

思路:01背包,这有一个坑,概率,连续偷不被抓的概率是相乘的,而且我们要用的是不被抓的概率,所以这个是

dp[j]=max(dp[j],dp[j-a[i]]*(1-b[i]));

#include<iostream>
#include<cstring.>
#include<cstdio>
using namespace std;
int t,m,n,a[105];
double p,b[105],dp[10005];
int main()
{
scanf("%d",&t);
while(t--)
{
m=0;
scanf("%lf%d",&p,&n);
for(int i=0; i<n; i++)
{
scanf("%d%lf",&a[i],&b[i]);
m+=a[i];
}
for(int i=0; i<=m; i++)
{
dp[i]=0.0;
}
dp[0]=1.0;
for(int i=0; i<n; i++)
{
for(int j=m; j>=a[i]; j--)
{
dp[j]=max(dp[j],dp[j-a[i]]*(1-b[i]));
}
}
for(int i=m; i>=0; i--)
{
if(dp[i]>=(1-p))
{
printf("%d\n",i);
break;
}
}
}
return 0;
}


 
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  acm 背包